import os.path

from django_configglue.utils import configglue

from identityprovider.schema import SSOSchema


# get absolute path for config files
current_dir = os.path.dirname(os.path.abspath(__file__))
config_files = map(lambda x: os.path.join(current_dir, x),
                   ['config/main.cfg', 'local.cfg'])

# parse config files
parser = configglue(SSOSchema, config_files, locals())

# keep parser reference
__CONFIGGLUE_PARSER__ = parser
