
YUI.add('lazr.autocomplete',function(Y){Y.namespace('lazr');var AUTOCOMP='autocomplete',BOUNDING_BOX='boundingBox',CONTENT_BOX='contentBox',INPUT='input',VALUE='value',QUERY='query',DATA='data',MATCHES='matches',RENDERED='rendered',DELIMITER='delimiter',TAB=9,RETURN=13,ESCAPE=27,ARROW_DOWN=40,getCN=Y.ClassNameManager.getClassName,C_LIST=getCN(AUTOCOMP,'list');var AutoCompleteBase=Y.Base.build("AutoCompleteBase",Y.Widget,[Y.WidgetStack]);function AutoComplete(){AutoComplete.superclass.constructor.apply(this,arguments);}
AutoComplete.NAME='autocomplete';AutoComplete.LIST_TEMPLATE='<ul></ul>';AutoComplete.ITEM_TEMPLATE='<li class="item yui-menuitem"></li>';AutoComplete.ITEM_CONTENT_TEMPLATE='<a href="#" class="yui-menuitem-content"></a>';AutoComplete.ATTRS={data:{valueFn:function(){return{};}},delimiter:{value:' '},matches:{valueFn:function(){return[];}},input:{value:null,setter:function(val){return this._setInput(val);}},query:{value:null}};Y.extend(AutoComplete,AutoCompleteBase,{_completions:null,_last_input_was_completed:false,initializer:function(){this.hide();if(Y.UA.opera||Y.UA.ie){this.disable();this.render=function(){};}},destructor:function(){var input=this.get('INPUT');if(input&&this.get(RENDERED)){input.detach('keydown',this._onInputKeydown);input.detach('keyup',this._onInputKeyup);}},renderUI:function(){var input=this.get(INPUT);var bounding_box=this.get(BOUNDING_BOX);bounding_box.addClass("yui-menu");Y.get('body').appendChild(bounding_box);this.get(CONTENT_BOX).setStyle('minWidth',input.get('offsetWidth')+"px").addClass('yui-menu-content');var iregion=input.get('region');bounding_box.setStyles({'left':iregion.left+'px','top':iregion.bottom+'px'});},_renderCompletions:function(query){var matches=this.get(MATCHES);if(!this.get(RENDERED)||!matches){return;}
var list=Y.Node.create(AutoComplete.LIST_TEMPLATE);list.addClass(C_LIST);var result;var item;var match;for(var idx=0;idx<matches.length;idx++){match=matches[idx];result=this.formatResult(match.text,query,match.offset);item=this._renderCompletion(result,idx);list.appendChild(item);}
var cbox=this.get(CONTENT_BOX);this.get(BOUNDING_BOX).unplug(Y.Plugin.NodeMenuNav);if(this._completions){cbox.replaceChild(list,this._completions);}else{cbox.appendChild(list);}
this.get(BOUNDING_BOX).plug(Y.Plugin.NodeMenuNav);this._selectItem(0,false);this._completions=list;},_renderCompletion:function(html_content,item_index){var item=Y.Node.create(AutoComplete.ITEM_TEMPLATE);item.setAttribute('id',this._makeItemID(item_index));var link=Y.Node.create(AutoComplete.ITEM_CONTENT_TEMPLATE);link.set('innerHTML',html_content);item.appendChild(link);return item;},_makeItemID:function(index){return'item'+index;},_indexForItem:function(item){var id=parseInt(item.getAttribute('id').replace('item',''),10);return Y.Lang.isNumber(id)?id:null;},bindUI:function(){var input=this.get(INPUT);input.on('keydown',this._onInputKeydown,this);input.on('keyup',this._onInputKeyup,this);this.get('contentBox').on('click',this._onListClick,this);},parseQuery:function(input,caret_pos){if(caret_pos<=0){return null;}
if(!Y.Lang.isNumber(caret_pos)||(caret_pos>input.length)){caret_pos=input.length;}
var delimiter=this.get(DELIMITER);var start=input.lastIndexOf(delimiter,caret_pos-1);var end=input.indexOf(delimiter,caret_pos-1);if((start==end)&&(start!=-1)){return null;}
if(start==-1){start=0;}else{start++;}
if(end==-1){end=input.length;}
while((input[start]==' '||input[start]=='\t')&&(start<=end))
{start++;}
if(start==end){return null;}
var query={text:input.substring(start,end),offset:start};return query;},findMatches:function(query){var matches=this.filterResults(this.get(DATA),query);this.set(MATCHES,matches);return matches;},filterResults:function(data,query){var midx;var match_key;var match_string;var start_indicies=[];var lowercase_query=query.toLowerCase();if(data){Y.Array.each(data,function(match_key){match_string=match_key.toString();midx=match_string.toLowerCase().indexOf(lowercase_query);if(midx>-1){if(!start_indicies[midx]){start_indicies[midx]=[];}
start_indicies[midx].push(match_string);}});}
var matches=[];var match_set;for(var index=0;index<start_indicies.length;index++){match_set=start_indicies[index];if(match_set){Y.Array.each(match_set,function(match){matches.push({text:match,offset:index});});}}
return matches;},formatResult:function(result,query,offset){return this.markMatchingText(result,query,offset);},markMatchingText:function(text,query,offset){var start=offset;if(start<0||!query){return text;}
var end=start+query.length;var before=text.substring(0,start);var match=text.substring(start,end);var after=text.substring(end);match='<span class="matching-text">'+match+'</span>';return before+match+after;},completeInput:function(){var active_item=this.getActiveItem();if(active_item){var item_index=this._indexForItem(active_item);if(item_index!==null){this.completeInputUsingItem(item_index);}}else{this.completeInputUsingItem(0);}
this.get(INPUT).focus();this._last_input_was_completed=true;},completeInputUsingItem:function(match_num){var matches=this.get(MATCHES);if(matches.length===0){return;}
if(match_num>=matches.length){Y.fail("Failed to complete item number "+match_num+" because there are only "+matches.length+" matches "+"available.");return;}
var completion_txt=matches[match_num].text;var query=this.get(QUERY);var delimiter=this.get(DELIMITER);var input=this.get(INPUT);var input_txt=input.get('value');var query_end=query.offset+query.text.length;var input_head=input_txt.substring(0,query.offset);var input_tail=input_txt.substring(query_end,input_txt.length);var tail_delimiter=delimiter;if(input_tail.charAt(input_tail.length-1)==delimiter){tail_delimiter='';}
var new_input=[input_head,completion_txt,input_tail,tail_delimiter].join('');input.set(VALUE,new_input);this.hide();},getActiveItem:function(){var menu=this.get(BOUNDING_BOX).menuNav;if(menu){return menu._activeItem?menu._activeItem:null;}
return null;},_selectItem:function(index,set_focus){var menu=this.get(BOUNDING_BOX).menuNav;var firstItem=menu._rootMenu.all('.yui-menuitem').item(0)
var item=menu?firstItem:null;if(!menu||!item){return null;}
for(var idx=0;idx<index;idx++){item=item.next();if(!item){return null;}}
if(set_focus){var anchor=item.one('a');menu._focusManager.set("activeDescendant",anchor);menu._focusItem(item);if(anchor){Y.later(5,anchor,anchor.focus);}}
menu._setActiveItem(item);return item;},_setInput:function(elem){var node=Y.get(elem);if(node===null){return null;}
Y.augment(node,Y.lazr.NodeCaretPos);return node;},_onInputKeyup:function(e){var input=this.get(INPUT);var caret_pos=null;if(input.getCaretPos!==undefined){caret_pos=input.getCaretPos();}
var query=this.parseQuery(input.get(VALUE),caret_pos);this.set(QUERY,query);if(e.keyCode===ESCAPE||e.keyCode===RETURN||e.keyCode===TAB||e.keyCode===ARROW_DOWN){return;}
if(query===null){this._last_input_was_completed=false;this.hide();return;}
if(this.findMatches(query.text).length!==0){this._renderCompletions(query.text);this._last_input_was_completed=false;this.show();}else{this.hide();}},_onInputKeydown:function(e){if(e.keyCode===TAB||e.keyCode===RETURN){if(this.get(QUERY)!==null&&!this._last_input_was_completed){this.completeInput();e.preventDefault();}}else if(e.keyCode===ESCAPE){this.hide();}else if(e.keyCode===ARROW_DOWN){this._selectItem(1,true);e.preventDefault();}},_onListClick:function(e){this.completeInput();e.preventDefault();}});Y.lazr.AutoComplete=AutoComplete;Y.lazr.NodeCaretPos=function(){};Y.lazr.NodeCaretPos.prototype.getCaretPos=function(){var elem=Y.Node.getDOMNode(this);if(Y.UA.ie){if(document.selection){var range=document.selection.createRange();range.moveToElementText(elem);return range.text.length;}}else if(typeof elem.selectionEnd!="undefined"){return elem.selectionEnd;}
return null;};},"0.1",{"skinnable":true,"requires":["oop","base","event","widget","widget-stack","node-menunav"]});