from django.template import Node


class CsrfTokenNode(Node):
    # This no-op tag exists to allow 1.1.X code to be compatible with Django 1.2
    def render(self, context):
        return u''


def csrf_token(parser, token):
    # This no-op tag exists to allow 1.1.X code to be compatible with Django 1.2
    return CsrfTokenNode()
