# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

from django.db.backends.postgresql_psycopg2 import base

DatabaseError = base.DatabaseError
IntegrityError = base.IntegrityError


class DatabaseWrapper(base.DatabaseWrapper):

    def cursor(self):
        from django.conf import settings
        cursor = self._cursor()
        return self.make_debug_cursor(cursor)
