var LAZR_MODULES = (function(){
  var ANIM = "anim",
  BASE = "base",
  CSS = "css",
  CSSFONTS = "cssfonts",
  CSSFONTS_CONTEXT = "cssfonts-context",
  CSSGRIDS = "cssgrids",
  CSSGRIDS_CONTEXT = "cssgrids-context",
  CSSRESET = "cssreset",
  CSSRESET_CONTEXT = "cssreset-context",
  EVENT = "event",
  JS = "js",
  LAZR_ANIM = "lazr.anim",
  LAZR_BASE = "lazr.base",
  LAZR_EFFECTS = "lazr.effects",
  LAZR_ERROR = "lazr.error",
  LAZR_OVERLAY = "lazr.overlay",
  NODE = "node",
  OOP = "oop",
  OVERLAY = "overlay",
  SKIN_SAM_ANIM = "skin-sam-anim",
  SKIN_SAM_BASE = "skin-sam-base",
  SKIN_SAM_EVENT = "skin-sam-event",
  SKIN_SAM_EVENT_DELEGATE = "skin-sam-event-delegate",
  SKIN_SAM_EVENT_FOCUS = "skin-sam-event-focus",
  SKIN_SAM_LAZR_ACTIVATOR_CORE = "skin-sam-lazr.activator+core",
  SKIN_SAM_LAZR_ANIM = "skin-sam-lazr.anim",
  SKIN_SAM_LAZR_AUTOCOMPLETE_CORE = "skin-sam-lazr.autocomplete+core",
  SKIN_SAM_LAZR_BASE = "skin-sam-lazr.base",
  SKIN_SAM_LAZR_CHOICEEDIT_CORE = "skin-sam-lazr.choiceedit+core",
  SKIN_SAM_LAZR_EDITOR_CORE = "skin-sam-lazr.editor+core",
  SKIN_SAM_LAZR_ERROR = "skin-sam-lazr.error",
  SKIN_SAM_LAZR_ERROR_CORE = "skin-sam-lazr.error+core",
  SKIN_SAM_LAZR_ERROR_MINIMAL_ERROR_WIDGET_ERROR_CORE = "skin-sam-lazr.error.minimal-error-widget+error+core",
  SKIN_SAM_LAZR_FORMOVERLAY_CORE = "skin-sam-lazr.formoverlay+core",
  SKIN_SAM_LAZR_OVERLAY = "skin-sam-lazr.overlay",
  SKIN_SAM_LAZR_OVERLAY_CORE = "skin-sam-lazr.overlay+core",
  SKIN_SAM_LAZR_PASSWORDMETER_CORE = "skin-sam-lazr.passwordmeter+core",
  SKIN_SAM_LAZR_PICKER_CORE = "skin-sam-lazr.picker+core",
  SKIN_SAM_NODE = "skin-sam-node",
  SKIN_SAM_NODE_MENUNAV = "skin-sam-node-menunav",
  SKIN_SAM_OOP = "skin-sam-oop",
  SKIN_SAM_OVERLAY = "skin-sam-overlay",
  SKIN_SAM_PLUGIN = "skin-sam-plugin",
  SKIN_SAM_SUBSTITUTE = "skin-sam-substitute",
  SKIN_SAM_WIDGET = "skin-sam-widget",
  SKIN_SAM_WIDGET_POSITION = "skin-sam-widget-position",
  SKIN_SAM_WIDGET_POSITION_EXT = "skin-sam-widget-position-ext",
  SKIN_SAM_WIDGET_STACK = "skin-sam-widget-stack",
  SKIN_SAM_WIDGET_STDMOD = "skin-sam-widget-stdmod",
  WIDGET = "widget",
  WIDGET_STACK = "widget-stack",
  WIDGET_STDMOD = "widget-stdmod";
  return {"skin-sam-lazr.picker": {"requires": [SKIN_SAM_LAZR_PICKER_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_EVENT_FOCUS, SKIN_SAM_NODE, SKIN_SAM_PLUGIN, SKIN_SAM_SUBSTITUTE, SKIN_SAM_WIDGET, SKIN_SAM_WIDGET_STDMOD, SKIN_SAM_LAZR_OVERLAY, SKIN_SAM_LAZR_ANIM, SKIN_SAM_LAZR_BASE, SKIN_SAM_LAZR_PICKER_CORE], "ext": false, "path": "lazr/picker/assets/skins/sam/picker-skin.css", "type": CSS}, "lazr.effects-async": {"path": "lazr/effects/effects-async-min.js", "ext": false, "requires": [NODE, EVENT, "io-base", LAZR_BASE, LAZR_EFFECTS, LAZR_ANIM], "type": JS}, "skin-sam-lazr.error.minimal-error-widget+error+core": {"path": "lazr/error/assets/error-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_ERROR], "type": CSS}, "skin-sam-lazr.error.minimal-error-widget+error": {"requires": [SKIN_SAM_LAZR_ERROR_MINIMAL_ERROR_WIDGET_ERROR_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_ERROR, SKIN_SAM_LAZR_ERROR_MINIMAL_ERROR_WIDGET_ERROR_CORE], "ext": false, "path": "lazr/error/assets/skins/sam/error-skin.css", "type": CSS}, "skin-sam-lazr.base": {"path": "lazr/lazr/assets/skins/sam/lazr-skin.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, "skin-sam-classnamemanager"], "type": CSS}, "lazr.choiceedit": {"type": JS, "ext": false, "path": "lazr/choiceedit/choiceedit-min.js", "requires": [OOP, EVENT, "event-delegate", NODE, WIDGET, WIDGET_STDMOD, OVERLAY, LAZR_OVERLAY, LAZR_ANIM, LAZR_BASE], "skinnable": true}, "skin-sam-lazr.picker+core": {"path": "lazr/picker/assets/picker-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_EVENT_FOCUS, SKIN_SAM_NODE, SKIN_SAM_PLUGIN, SKIN_SAM_SUBSTITUTE, SKIN_SAM_WIDGET, SKIN_SAM_WIDGET_STDMOD, SKIN_SAM_LAZR_OVERLAY, SKIN_SAM_LAZR_ANIM, SKIN_SAM_LAZR_BASE], "type": CSS}, "skin-sam-lazr.effects": {"path": "lazr/effects/assets/skins/sam/effects-skin.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_ANIM, SKIN_SAM_NODE], "type": CSS}, "skin-sam-lazr.error+core": {"path": "lazr/error/assets/error-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_LAZR_OVERLAY], "type": CSS}, "skin-sam-lazr.autocomplete": {"requires": [SKIN_SAM_LAZR_AUTOCOMPLETE_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_BASE, SKIN_SAM_EVENT, SKIN_SAM_WIDGET, SKIN_SAM_WIDGET_STACK, SKIN_SAM_NODE_MENUNAV, SKIN_SAM_LAZR_AUTOCOMPLETE_CORE], "ext": false, "path": "lazr/autocomplete/assets/skins/sam/autocomplete-skin.css", "type": CSS}, "skin-sam-lazr.overlay+core": {"path": "lazr/overlay/assets/pretty-overlay-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_OVERLAY, SKIN_SAM_EVENT, SKIN_SAM_WIDGET, SKIN_SAM_WIDGET_STACK, SKIN_SAM_WIDGET_POSITION, SKIN_SAM_WIDGET_POSITION_EXT], "type": CSS}, "lazr.picker": {"type": JS, "ext": false, "path": "lazr/picker/picker-min.js", "requires": [OOP, EVENT, "event-focus", NODE, "plugin", "substitute", WIDGET, WIDGET_STDMOD, LAZR_OVERLAY, LAZR_ANIM, LAZR_BASE], "skinnable": true}, "lazr.activator": {"type": JS, "ext": false, "path": "lazr/activator/activator-min.js", "requires": [OOP, EVENT, NODE, WIDGET, LAZR_ANIM, LAZR_BASE], "skinnable": true}, "lazr.autocomplete": {"type": JS, "ext": false, "path": "lazr/autocomplete/autocomplete-min.js", "requires": [OOP, BASE, EVENT, WIDGET, WIDGET_STACK, "node-menunav"], "skinnable": true}, "skin-sam-lazr.passwordmeter+core": {"path": "lazr/passwordmeter/assets/passwordmeter-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_BASE], "type": CSS}, "skin-sam-lazr.formoverlay": {"requires": [SKIN_SAM_LAZR_FORMOVERLAY_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_LAZR_OVERLAY, SKIN_SAM_LAZR_FORMOVERLAY_CORE], "ext": false, "path": "lazr/formoverlay/assets/skins/sam/formoverlay-skin.css", "type": CSS}, "skin-sam-lazr.autocomplete+core": {"path": "lazr/autocomplete/assets/autocomplete-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_BASE, SKIN_SAM_EVENT, SKIN_SAM_WIDGET, SKIN_SAM_WIDGET_STACK, SKIN_SAM_NODE_MENUNAV], "type": CSS}, "skin-sam-lazr.editor": {"requires": [SKIN_SAM_LAZR_EDITOR_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_ANIM, SKIN_SAM_EVENT, SKIN_SAM_NODE, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_ANIM, SKIN_SAM_LAZR_BASE, SKIN_SAM_LAZR_EDITOR_CORE], "ext": false, "path": "lazr/inlineedit/assets/skins/sam/editor-skin.css", "type": CSS}, "skin-sam-lazr.formoverlay+core": {"path": "lazr/formoverlay/assets/formoverlay-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_LAZR_OVERLAY], "type": CSS}, "skin-sam-lazr.activator": {"requires": [SKIN_SAM_LAZR_ACTIVATOR_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_NODE, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_ANIM, SKIN_SAM_LAZR_BASE, SKIN_SAM_LAZR_ACTIVATOR_CORE], "ext": false, "path": "lazr/activator/assets/skins/sam/activator-skin.css", "type": CSS}, "lazr.error.minimal-error-widget": {"type": JS, "ext": false, "path": "lazr/error/error-widget-minimal-min.js", "requires": [OOP, EVENT, WIDGET, LAZR_ERROR], "skinnable": true}, "lazr.overlay": {"type": JS, "ext": false, "path": "lazr/overlay/overlay-min.js", "requires": [OOP, OVERLAY, EVENT, WIDGET, WIDGET_STACK, "widget-position", "widget-position-ext"], "skinnable": true}, "lazr.editor": {"type": JS, "ext": false, "path": "lazr/inlineedit/editor-min.js", "requires": [OOP, ANIM, EVENT, NODE, WIDGET, LAZR_ANIM, LAZR_BASE], "skinnable": true}, "lazr.error": {"type": JS, "ext": false, "path": "lazr/error/error-min.js", "requires": [LAZR_OVERLAY], "skinnable": true}, "skin-sam-lazr.overlay": {"requires": [SKIN_SAM_LAZR_OVERLAY_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_OVERLAY, SKIN_SAM_EVENT, SKIN_SAM_WIDGET, SKIN_SAM_WIDGET_STACK, SKIN_SAM_WIDGET_POSITION, SKIN_SAM_WIDGET_POSITION_EXT, SKIN_SAM_LAZR_OVERLAY_CORE], "ext": false, "path": "lazr/overlay/assets/skins/sam/pretty-overlay-skin.css", "type": CSS}, "skin-sam-lazr.choiceedit": {"requires": [SKIN_SAM_LAZR_CHOICEEDIT_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_EVENT_DELEGATE, SKIN_SAM_NODE, SKIN_SAM_WIDGET, SKIN_SAM_WIDGET_STDMOD, SKIN_SAM_OVERLAY, SKIN_SAM_LAZR_OVERLAY, SKIN_SAM_LAZR_ANIM, SKIN_SAM_LAZR_BASE, SKIN_SAM_LAZR_CHOICEEDIT_CORE], "ext": false, "path": "lazr/choiceedit/assets/skins/sam/choiceedit-skin.css", "type": CSS}, "skin-sam-lazr.choiceedit+core": {"path": "lazr/choiceedit/assets/choiceedit-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_EVENT_DELEGATE, SKIN_SAM_NODE, SKIN_SAM_WIDGET, SKIN_SAM_WIDGET_STDMOD, SKIN_SAM_OVERLAY, SKIN_SAM_LAZR_OVERLAY, SKIN_SAM_LAZR_ANIM, SKIN_SAM_LAZR_BASE], "type": CSS}, "skin-sam-lazr.error.minimal-error-widget": {"path": "lazr/error/assets/skins/sam/minimal-error-widget-skin.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_ERROR], "type": CSS}, "skin-sam-lazr.error": {"requires": [SKIN_SAM_LAZR_ERROR_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_LAZR_OVERLAY, SKIN_SAM_LAZR_ERROR_CORE], "ext": false, "path": "lazr/error/assets/skins/sam/error-skin.css", "type": CSS}, "lazr.anim": {"path": "lazr/anim/anim-min.js", "ext": false, "requires": [BASE, NODE, ANIM], "type": JS}, "lazr.formoverlay": {"type": JS, "ext": false, "path": "lazr/formoverlay/formoverlay-min.js", "requires": [LAZR_OVERLAY], "skinnable": true}, "lazr.passwordmeter": {"type": JS, "ext": false, "path": "lazr/passwordmeter/passwordmeter-min.js", "requires": [WIDGET, LAZR_BASE], "skinnable": true}, "lazr.actions": {"path": "lazr/actions/actions-min.js", "ext": false, "requires": [OOP, BASE, NODE, LAZR_BASE], "type": JS}, "skin-sam-lazr.error+minimal-error-widget": {"path": "lazr/error/assets/skins/sam/minimal-error-widget-skin.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_LAZR_OVERLAY], "type": CSS}, "skin-sam-lazr.passwordmeter": {"requires": [SKIN_SAM_LAZR_PASSWORDMETER_CORE], "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_BASE, SKIN_SAM_LAZR_PASSWORDMETER_CORE], "ext": false, "path": "lazr/passwordmeter/assets/skins/sam/passwordmeter-skin.css", "type": CSS}, "lazr.base": {"type": JS, "ext": false, "path": "lazr/lazr/lazr-min.js", "requires": ["classnamemanager"], "skinnable": true}, "skin-sam-lazr.activator+core": {"path": "lazr/activator/assets/activator-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_EVENT, SKIN_SAM_NODE, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_ANIM, SKIN_SAM_LAZR_BASE], "type": CSS}, "lazr.effects": {"type": JS, "ext": false, "path": "lazr/effects/effects-min.js", "requires": [ANIM, NODE], "skinnable": true}, "skin-sam-lazr.editor+core": {"path": "lazr/inlineedit/assets/editor-core.css", "ext": false, "after": [CSSRESET, CSSFONTS, CSSGRIDS, CSSRESET_CONTEXT, CSSFONTS_CONTEXT, CSSGRIDS_CONTEXT, SKIN_SAM_OOP, SKIN_SAM_ANIM, SKIN_SAM_EVENT, SKIN_SAM_NODE, SKIN_SAM_WIDGET, SKIN_SAM_LAZR_ANIM, SKIN_SAM_LAZR_BASE], "type": CSS}};
})();