from wsgi_intercept import add_wsgi_intercept
from wsgi_intercept.urllib2_intercept import install_opener

from identityprovider.wsgi import make_app


def setup_package():
    install_opener()

    add_wsgi_intercept('openid.launchpad.dev', 80, make_app)
    add_wsgi_intercept('launchpad.dev', 80, make_app)
    add_wsgi_intercept('localhost', 80, make_app)
